unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, Dxcore,
  activex;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_ContractListNX, U_ContractListWX, U_ContractListCG,
  U_ContractListJG;      

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmContractListNXLL, frmContractListNXSH, frmContractListNXCX: TfrmContractListNX;
  frmContractListWXLL, frmContractListWXSH, frmContractListWXCX: TfrmContractListWX;
  frmContractListCGLL, frmContractListCGSH, frmContractListCGCX: TfrmContractListCG;
  frmContractListJGLL, frmContractListJGSH, frmContractListJGCX: TfrmContractListJG;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '47.100.130.130,7781';
//  server := '.';
  dtbase := 'zhenyongdata';
  user := 'zhenyongsa';
  pswd := 'rightsoft@9101';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;
//   DName:='周高祥';
 // DParameters1:='高权限';
   //DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //内销合同录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '内销合同录入' then
          begin
            BringWindowToTop(frmContractListNXLL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListNXLL := TfrmContractListNX.Create(application.MainForm);
          with frmContractListNXLL do
          begin
            Title := '内销合同录入';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListNXLL.BringToFront;
       //句柄
        mnewHandle := frmContractListNXLL.Handle;
      end;

    112:  //内销合同审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '内销合同审核' then
          begin
            BringWindowToTop(frmContractListNXSH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListNXSH := TfrmContractListNX.Create(application.MainForm);
          with frmContractListNXSH do
          begin
            Title := '内销合同审核';
            canshu1 := '审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListNXSH.BringToFront;
       //句柄
        mnewHandle := frmContractListNXSH.Handle;
      end;

    113:  //内销合同查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '内销合同查询' then
          begin
            BringWindowToTop(frmContractListNXCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListNXCX := TfrmContractListNX.Create(application.MainForm);
          with frmContractListNXCX do
          begin
            Title := '内销合同查询';
            canshu1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListNXCX.BringToFront;
       //句柄
        mnewHandle := frmContractListNXCX.Handle;
      end;

    211:  //外销合同录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '外销合同录入' then
          begin
            BringWindowToTop(frmContractListWXLL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListWXLL := TfrmContractListWX.Create(application.MainForm);
          with frmContractListWXLL do
          begin
            Title := '外销合同录入';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListWXLL.BringToFront;
       //句柄
        mnewHandle := frmContractListWXLL.Handle;
      end;

    212:  //外销合同审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '外销合同审核' then
          begin
            BringWindowToTop(frmContractListWXSH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListWXSH := TfrmContractListWX.Create(application.MainForm);
          with frmContractListWXSH do
          begin
            Title := '外销合同审核';
            canshu1 := '审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListWXSH.BringToFront;
       //句柄
        mnewHandle := frmContractListWXSH.Handle;
      end;
    213:  //外销合同查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '外销合同查询' then
          begin
            BringWindowToTop(frmContractListWXCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListWXCX := TfrmContractListWX.Create(application.MainForm);
          with frmContractListWXCX do
          begin
            Title := '外销合同查询';
            canshu1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListWXCX.BringToFront;
       //句柄
        mnewHandle := frmContractListWXCX.Handle;
      end;
    311:  //采购合同录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '采购申请' then
          begin
            BringWindowToTop(frmContractListCGLL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListCGLL := TfrmContractListCG.Create(application.MainForm);
          with frmContractListCGLL do
          begin
            Title := '采购合同录入';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListCGLL.BringToFront;
       //句柄
        mnewHandle := frmContractListCGLL.Handle;
      end;

    312:  //采购合同审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '采购合同' then
          begin
            BringWindowToTop(frmContractListCGSH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListCGSH := TfrmContractListCG.Create(application.MainForm);
          with frmContractListCGSH do
          begin
            Title := '采购合同审核';
            canshu1 := '审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListCGSH.BringToFront;
       //句柄
        mnewHandle := frmContractListCGSH.Handle;
      end;
    313:  //采购合同查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '采购合同查询' then
          begin
            BringWindowToTop(frmContractListCGCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListCGCX := TfrmContractListCG.Create(application.MainForm);
          with frmContractListCGCX do
          begin
            Title := '采购合同查询';
            canshu1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListCGCX.BringToFront;
       //句柄
        mnewHandle := frmContractListCGCX.Handle;
      end;

    411:  //加工合同录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '加工合同录入' then
          begin
            BringWindowToTop(frmContractListJGLL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListJGLL := TfrmContractListJG.Create(application.MainForm);
          with frmContractListJGLL do
          begin
            Title := '加工合同录入';
            caption := Trim(Title);
            canshu1 := '录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListJGLL.BringToFront;
       //句柄
        mnewHandle := frmContractListJGLL.Handle;
      end;

    412:  //加工合同审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '加工合同审核' then
          begin
            BringWindowToTop(frmContractListJGSH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListJGSH := TfrmContractListJG.Create(application.MainForm);
          with frmContractListJGSH do
          begin
            Title := '加工合同审核';
            canshu1 := '审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListJGSH.BringToFront;
       //句柄
        mnewHandle := frmContractListJGSH.Handle;
      end;
    413:  //加工合同查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '加工合同查询' then
          begin
            BringWindowToTop(frmContractListJGCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmContractListJGCX := TfrmContractListJG.Create(application.MainForm);
          with frmContractListJGCX do
          begin
            Title := '加工合同查询';
            canshu1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmContractListJGCX.BringToFront;
       //句柄
        mnewHandle := frmContractListJGCX.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_ContractManagement) then
    DataLink_ContractManagement := TDataLink_ContractManagement.Create(Application);
  try
    with DataLink_ContractManagement.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_ContractManagement.Free;
//  Application := OldDllApp;
initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_ContractManagement.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

